/*
** Permutation Generator.
** ---------------------
**
** Ordering of genes on plants
** with respect to Tobacco genes.
** i.e.: Tobacco ordering: <1 2 3 ... 105>
**
** Auhtor: Dimitris Diochnos
**
** Date: Wednesday, 30th June 2004.
**
*/

#include <stdio.h>
#include <string.h>

#define FILENAME_BUFFER 64

int 	main (void)
{
	FILE * 	fd;
	char 	fileName [FILENAME_BUFFER];
	int 	N = 105, i;

	/* Generating Trachelium. */
	strcpy (fileName, "Trachelium.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Trachelium.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	for (i = 1; i <= 15; i++)
		fprintf (fd, "\n%d", i);
	for (i = 76; i >= 56; i--)
		fprintf (fd, "\n%d", i);
	for (i = 53; i >= 49; i--)
		fprintf (fd, "\n%d", i);
	for (i = 37; i <= 40; i++)
		fprintf (fd, "\n%d", i);
	for (i = 35; i >= 26; i--)
		fprintf (fd, "\n%d", i);
	for (i = 44; i >= 41; i--)
		fprintf (fd, "\n%d", i);
	for (i = 45; i <= 48; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", -36);
	for (i = 25; i >= 16; i--)
		fprintf (fd, "\n%d", i);
	for (i = 90; i >= 84; i--)
		fprintf (fd, "\n%d", i);
	for (i = 77; i <= 83; i++)
		fprintf (fd, "\n%d", i);
	for (i = 91; i <= 96; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n55");
	fprintf (fd, "\n54");
	for (i = 105; i >= 97; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	/* Generating Symphyandra. */
	for (i = 0; i < FILENAME_BUFFER; i++)
		fileName [i] = '\0';
	strcpy (fileName, "Symphyandra.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Symphyandra.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	for (i = 1; i <= 15; i++)
		fprintf (fd, "\n%d", i);
	for (i = 76; i >= 56; i--)
		fprintf (fd, "\n%d", i);
	for (i = 39; i >= 37; i--)
		fprintf (fd, "\n%d", i);
	for (i = 49; i <= 53; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n40");
	for (i = 35; i >= 26; i--)
		fprintf (fd, "\n%d", i);
	for (i = 44; i >= 41; i--)
		fprintf (fd, "\n%d", i);
	for (i = 45; i <= 48; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", -36);
	for (i = 25; i >= 16; i--)
		fprintf (fd, "\n%d", i);
	for (i = 90; i >= 84; i--)
		fprintf (fd, "\n%d", i);
	for (i = 77; i <= 83; i++)
		fprintf (fd, "\n%d", i);
	for (i = 91; i <= 96; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n55");
	fprintf (fd, "\n54");
	for (i = 105; i >= 97; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	/* Generating Triodanus. */
	for (i = 0; i < FILENAME_BUFFER; i++)
		fileName [i] = '\0';
	strcpy (fileName, "Triodanus.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Triodanus.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	for (i = 1; i <= 15; i++)
		fprintf (fd, "\n%d", i);
	for (i = 76; i >= 56; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n27\n26");
	for (i = 44; i >= 41; i--)
		fprintf (fd, "\n%d", i);
	for (i = 45; i <= 48; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n36\n35");
	for (i = 25; i >= 16; i--)
		fprintf (fd, "\n%d", i);
	for (i = 89; i >= 84; i--)
		fprintf (fd, "\n%d", i);
	for (i = 77; i <= 83; i++)
		fprintf (fd, "\n%d", i);
	for (i = 90; i <= 96; i++)
		fprintf (fd, "\n%d", i);
	for (i = 55; i >= 53; i--)
		fprintf (fd, "\n%d", i);
	for (i = 105; i >= 98; i--)
		fprintf (fd, "\n%d", i);
	for (i = 28; i <= 34; i++)
		fprintf (fd, "\n%d", i);
	for (i = 40; i >= 37; i--)
		fprintf (fd, "\n%d", i);
	for (i = 49; i <= 52; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", -97);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	/* Generating Merciera. */
	for (i = 0; i < FILENAME_BUFFER; i++)
		fileName [i] = '\0';
	strcpy (fileName, "Merciera.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Merciera.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	for (i = 1; i <= 10; i++)
		fprintf (fd, "\n%d", i);
	for (i = 49; i <= 53; i++)
		fprintf (fd, "\n%d", i);
	for (i = 28; i <= 35; i++)
		fprintf (fd, "\n%d", i);
	for (i = 40; i >= 37; i--)
		fprintf (fd, "\n%d", i);
	for (i = 60; i >= 56; i--)
		fprintf (fd, "\n%d", i);
	for (i = 11; i <= 15; i++)
		fprintf (fd, "\n%d", i);
	for (i = 76; i >= 61; i--)
		fprintf (fd, "\n%d", i);
	for (i = 27; i >= 26; i--)
		fprintf (fd, "\n%d", i);
	for (i = 44; i >= 41; i--)
		fprintf (fd, "\n%d", i);
	for (i = 45; i <= 48; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d\n54", -36);
	for (i = 25; i >= 16; i--)
		fprintf (fd, "\n%d", i);
	for (i = 90; i >= 85; i--)
		fprintf (fd, "\n%d", i);
	for (i = 77; i <= 84; i++)
		fprintf (fd, "\n%d", i);
	for (i = 91; i <= 96; i++)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", -55);
	for (i = 105; i >= 97; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	/* Generating Codonopsis. */
	for (i = 0; i < FILENAME_BUFFER; i++)
		fileName [i] = '\0';
	strcpy (fileName, "Codonopsis.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Codonopsis.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	for (i = 1; i <= 8; i++)
		fprintf (fd, "\n%d", i);
	for (i = 36; i >= 18; i--)
		fprintf (fd, "\n%d", i);
	for (i = 15; i >= 9; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n40");
	for (i = 56; i <= 60; i++)
		fprintf (fd, "\n%d", i);
	for (i = 37; i <= 39; i++)
		fprintf (fd, "\n%d", i);
	for (i = 44; i >= 41; i--)
		fprintf (fd, "\n%d", i);
	for (i = 45; i <= 53; i++)
		fprintf (fd, "\n%d", i);
	for (i = 16; i <= 17; i++)
		fprintf (fd, "\n%d", i);
	for (i = 54; i <= 55; i++)
		fprintf (fd, "\n%d", i);
	for (i = 61; i <= 76; i++)
		fprintf (fd, "\n%d", i);
	for (i = 96; i >= 77; i--)
		fprintf (fd, "\n%d", i);
	for (i = 105; i >= 97; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	/* Generating Platycodon. */
	for (i = 0; i < FILENAME_BUFFER; i++)
		fileName [i] = '\0';
	strcpy (fileName, "Platycodon.in");
	fd = fopen (fileName, "w");
	if (fd == (FILE *) NULL) {
		fprintf (stderr, "\nError generating %s file.\a\n", fileName);
		fprintf (stderr, "Perhaps you should close all open programs and re-run this file generator.\n");
	}
	printf ("Generating Platycodon.in file. Please wait ... ");
	fflush (stdout);
	fprintf (fd, "%d", N + 2);
	fprintf (fd, "\n0");
	fprintf (fd, "\n1\n8");
	for (i = 2; i <= 5; i++)
		fprintf (fd, "\n%d", i);
	for (i = 29; i <= 36; i++)
		fprintf (fd, "\n%d", i);
	for (i = 56; i >= 50; i--)
		fprintf (fd, "\n%d", i);
	for (i = 28; i >= 26; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n9");
	for (i = 49; i >= 45; i--)
		fprintf (fd, "\n%d", i);
	for (i = 41; i <= 44; i++)
		fprintf (fd, "\n%d", i);
	for (i = 37; i <= 40; i++)
		fprintf (fd, "\n%d", i);
	for (i = 16; i <= 25; i++)
		fprintf (fd, "\n%d", i);
	for (i = 10; i <= 15; i++)
		fprintf (fd, "\n%d", i);
	for (i = 57; i <= 59; i++)
		fprintf (fd, "\n%d", i);
	for (i = 6; i <= 7; i++)
		fprintf (fd, "\n%d", i);
	for (i = 60; i <= 96; i++)
		fprintf (fd, "\n%d", i);
	for (i = 105; i >= 97; i--)
		fprintf (fd, "\n%d", i);
	fprintf (fd, "\n%d", N + 1);

	fclose (fd);
	printf ("DONE!\n");


	return 	0;
}
